//+------------------------------------------------------------------+ 
//|   Modifications by TRO                                           | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne (TRO) |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

//+------------------------------------------------------------------+
//|                                         Opening_Range_Hourly.mq4 |
//|                                      Copyright  2008, Kris Pivo |
//|                                                    11 April 2008 |
//+------------------------------------------------------------------+
#property copyright " Tokarus"
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen   // Opening Range Buy Signal
#property indicator_color2 DimGray     // Opening Range High
#property indicator_color3 DimGray     // Opening Range Low
#property indicator_color4 Red         // Opening Range Sell Signal

extern   int  myThreshold = 2; 

//---- buffers
double OpenHS[];
double OpenHi[];
double OpenLo[];
double OpenLS[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
	//---- indicators
	SetIndexBuffer(0,OpenHS);
	SetIndexBuffer(1,OpenHi);
	SetIndexBuffer(2,OpenLo);
	SetIndexBuffer(3,OpenLS);
	
	SetIndexStyle(0,DRAW_LINE,STYLE_DOT);
	SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
	SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
	SetIndexStyle(3,DRAW_LINE,STYLE_DOT);

	string short_name = "Hourly Opening Range";
	IndicatorShortName(short_name);
	return(1);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
	ObjectDelete("OR HS");
	ObjectDelete("OR Hi");
	ObjectDelete("OR Lo");
	ObjectDelete("OR LS");
	Comment("Hourly Opening Range");
   ObjectDelete("orh1");    
   ObjectDelete("orh2");       
   ObjectDelete("orh3");    
   ObjectDelete("orh4"); 
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

double prevL=0, prevH=0, prevC=0, prevO=0;
double ORHS, ORHi, ORLo, ORLS, P=0;
int thisHour = -1;

int start() {
	if (Period() > 60) return(0);		//Chart cannot be higher than H1
	
	int counted_bars=IndicatorCounted();
	if (counted_bars >0) counted_bars--;
	int limit=Bars-counted_bars;

	int period = MathCeil(60 / Period());

	for (int i = limit-1; i>=0; i--) {
		if (i + period < Bars && TimeMinute(iTime(NULL,0,i)) == 0 && thisHour != TimeHour(iTime(NULL,0,i)) ) {
			thisHour = TimeHour(iTime(NULL,0,i));
			prevH = High[Highest(NULL, 0, MODE_HIGH, period, i+1)];
			prevL = Low [Lowest (NULL, 0, MODE_LOW,  period, i+1)];
			prevC = Close[i+1];

         ORHi = High[i];
         ORLo = Low[i];
         ORHS = ORHi +  myThreshold*Point;
         ORLS = ORLo -  myThreshold*Point;
         P  = (prevH + prevL + prevC)/3;
		}
		if (P > 0) {
			OpenHS[i] = ORHS;
			OpenHi[i] = ORHi;
			OpenLo[i] = ORLo;
			OpenLS[i] = ORLS;
			drawLabel("OR HS",ORHS, indicator_color1);
			drawLabel("OR Hi",ORHi, indicator_color2);
			drawLabel("OR Lo",ORLo, indicator_color3);
			drawLabel("OR LS",ORLS, indicator_color4);
		}
	}
	
	
DoLabel( "orh1" , OpenHS[0]  , LimeGreen ) ;	
DoLabel( "orh2" , OpenHi[0]  , DimGray ) ;		
DoLabel( "orh3" , OpenLo[0]  , DimGray ) ;	
DoLabel( "orh4" , OpenLS[0]  , Red ) ;	
	
	return(0);
}
//+------------------------------------------------------------------+
void drawLabel (string name,double lvl,color Color) 
   {
//   if (ObjectFind(name) != 0)
//      {
//		ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
//		ObjectSetText(name, name, 8, "Arial", EMPTY);
//		ObjectSet(name, OBJPROP_COLOR, Color);
//      }
// else
//    {
//		int x = 1 + MathCeil(10/Period());
//		ObjectMove(name, 0, Time[x], lvl);
//	   }
	return(0);
   }
//-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+


//+------------------------------------------------------------------+ 

void DoLabel( string dName, double dValue, color dColor )
{

     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],dValue);
      }
      
}
//+------------------------------------------------------------------+      
 